#include "stc.h"
#include "usb.h"

#include "HC595.h"
#include "SMG_LED.h"
#include "TIM0.h"
#include "KEY.h"
#include "Beep.h"

#define MAIN_Fosc 24000000UL	//ʱ

//USBԼλ趨
char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";   //ԶλISPûӿ

bit  TIM0_10MS_FLAG =  0;    /* ʱ0 10msʱʱ״̬־λ */

u8 PassWord[8] = { 1,2,3,4,5,6,7,8 };  /* 趨 */ 
u8 Pass_OK = 0;            /* ȷĸ */
u8 Matrix_Key_Value = 0;   /* ȡľֵ̼ */
u8 Key_Str = 0;            /*  0-7 */
u8 i = 0;
bit Open_Flag = 0;         /* رձ־λ */
u16 Time_Count = 0;        /* ʱ */

u16 NO_Press_Time_Count = 0;      /* û¼ʱ */
bit Sleep_Flag = 0;               /* ߱־λ */

void sys_init()
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫
    
	P3M0 &= ~0x03;
    P3M1 |= 0x03;
	
    //USBʹõʱԴ
    IRC48MCR = 0x80;    //ʹڲ48MIRC
    while (!(IRC48MCR & 0x01));  //ȴʱȶ
	
	USBCLK = 0x00;     //ʹCDCҪʹУHIDܴʱֹʹ
    USBCON = 0x90;
}

void main()
{
	sys_init();
    usb_init();     //USBʼ
	
	SMG_LED_Init();  /* LEDĳʼ */
	BEEP_Init();     /* ʼ */
	Timer0_Init();   /* ʱ0ʼ */
 
    EA = 1;    /* ж */
	
	while(1)
	{                     
		if(DeviceState != DEVSTATE_CONFIGURED)  /* жUSBǷӳɹ */
			continue;
		if(bUsbOutReady)    
		{
			usb_OUT_done();
		}
		
		if(TIM0_10MS_FLAG) /* ÿ10msһ */
		{
			TIM0_10MS_FLAG = 0;  /* 10msʱ־λ */
			
			BEEP_RUN();          /* ·״̬ */
			
			Matrix_Key_Value = Matrix_KEY_Read();   /* ȡֵ */
			
			if(Matrix_Key_Value>0)                  /* а */
			{
				NO_Press_Time_Count = 0;
				Sleep_Flag = 0;  
				BEEP_ON(2);                         /* 20ms */
				Show_Tab[Key_Str] = Matrix_Key_Value;
			    Key_Str++;
				Matrix_Key_Value = 0;
			}
			else    /* δ */
			{
				NO_Press_Time_Count++;
				if(NO_Press_Time_Count>=1000) /* ûµʱ䳬10 */
				{
					NO_Press_Time_Count = 0;
					Sleep_Flag = 1;            /*  */
				}
			}
			
			if( Key_Str == 8 )  /* ϣʼж */
			{
				Key_Str = 0;    /*  */
				
				for(i = 0; i<8; i++)
				{
					if( Show_Tab[i] ==  PassWord[i])  //ȶ
					{
						Pass_OK++;     /* ȷһ */
					}
				}
				if(Pass_OK == 8)       /* ȫȷ */
				{
					LED0 = 0;          /*  */
					Open_Flag = 1;     /* ű־λ1 */
					Pass_OK = 0;       /* ȷ0 */
				}
				else                   /*  */
				{
					BEEP_ON(200);      /* 2 */
					Pass_OK = 0;       /* ȷ0 */
				}
				Show_Tab[0] = Show_Tab[1] = Show_Tab[2] = Show_Tab[3] = Show_Tab[4] = Show_Tab[5] = Show_Tab[6] = Show_Tab[7] = 20;
			}
			
			if(Open_Flag)   /* Ŵˣ5֮Զر */
			{
				Time_Count++;          //10msۼһ
				if(Time_Count>=500)    //ź5ʱ䵽
				{
					Open_Flag = 0;     /* ű־λ0 */
					Time_Count = 0;    /* ۼӱ0 */
					LED0 = 1;          /*  */
				}
			}
			
			
		}
	}
}

/*******************************************************************************
*  : Timer0_Isr
*  : ʱ0жϷ
* ڲ : 
*  : 
* ע : ÿ1msһжϷ
*******************************************************************************/
void Timer0_Isr(void) interrupt 1   
{
	static u16 Time_Count = 0;
	
	Time_Count++;
	
	if(Time_Count>=10)
	{
		Time_Count = 0;
		TIM0_10MS_FLAG = 1;
	}
	if( Sleep_Flag )
	{
		Send_595(0x00) ; /* ر */
	}
	else
	{
		SMG_LED_Show();  /* ÿ1msһLEDˢ */
	}
	
}
















